/**
 * @file          /ks-license/src/daemon/license-machine.h
 * @brief         
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved. 
 */

#pragma once

#include "lib/base/base.h"

struct _GUdevClient;
struct _GUdevDevice;
typedef struct _GUdevClient GUdevClient;
typedef struct _GUdevDevice GUdevDevice;

namespace Daemon
{
class LicenseMachine
{
public:
    LicenseMachine();
    virtual ~LicenseMachine();

    void init();

    // 获取机器码
    std::string get_machine_code();

    // 加载MAC地址
    void load_mac_addrs();

private:
    // 获取MAC地址列表
    std::vector<std::string> get_addrs();

    // 是否为全0地址
    bool is_full_zero_addrs(const std::string &addr);

    bool idle_load_mac_addrs();

    static void on_uevent_changed(GUdevClient *client, gchar *action, GUdevDevice *device, gpointer user_data);

private:
    GUdevClient *udev_client_;
    uint64_t udev_client_handler_;
};

}  // namespace Daemon
