/**
 * @file          /ks-license/src/daemon/license-object-os-hw-joint.h
 * @brief
 * @author        xiaowen <xiaowen@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved.
 */

#pragma once

#include "license-object-os.h"
#include "yum-repo-control.h"
namespace Daemon
{
class LicenseObjectOSHWJoint : public LicenseObjectOS
{
private:
    /* data */
public:
    LicenseObjectOSHWJoint(const std::string &name);
    ~LicenseObjectOSHWJoint();

private:
    void update_certificate_file();
    bool is_updating_certificate();
    bool timing_check_certificate();
    void on_activation_success();

private:
    std::shared_ptr<YumRepoControl> yum_repo_control_;
    sigc::connection certificate_timer_;
};

}  // namespace Daemon