/**
 * @file          /ks-license/src/daemon/license-object-os.h
 * @brief
 * @author        tangjie02 <tangjie02@kylinos.com.cn>
 * @copyright (c) 2020 KylinSec. All rights reserved.
 */

#pragma once

#include "src/daemon/license-object.h"

namespace Daemon
{
class LicenseObjectOS : public LicenseObject
{
public:
    LicenseObjectOS(const std::string& name);
    virtual ~LicenseObjectOS();

    // 注册激活状态
    void regist_license_state(int days, std::shared_ptr<sigc::signal<void>> signal);
    // 清空激活状态
    void clear_license_state() { this->license_status_.clear(); };

    sigc::signal<void> signal_check_license_state() { return this->check_license_state_; }

private:
    bool timing_check_status();

private:
    // 定时器，用于定时检查授权状态
    sigc::connection status_check_timer_;
    // license状态检测表，主键为到期时间，值为操作信号
    std::map<int, std::shared_ptr<sigc::signal<void>>> license_status_;
    sigc::signal<void> check_license_state_;
};
}  // namespace Daemon